diff --git a/src/extern.h b/src/extern.h
index 4e44024..4332078 100644
--- a/src/extern.h
+++ b/src/extern.h
@@ -52,7 +52,7 @@ extern char *MakeWinMsg __P((char *, struct win *, int));
 extern char *MakeWinMsgEv __P((char *, struct win *, int, int, struct event *, int));
 extern int   AddWinMsgRend __P((const char *, int));
 extern void  PutWinMsg __P((char *, int, int));
-#ifdef BSDWAIT
+#ifndef HAVE_SYS_WAIT_H
 extern void  WindowDied __P((struct win *, union wait, int));
 #else
 extern void  WindowDied __P((struct win *, int, int));
diff --git a/src/misc.c b/src/misc.c
index c56d87a..4105e2d 100644
--- a/src/misc.c
+++ b/src/misc.c
@@ -455,7 +455,7 @@ UserStatus()
 {
 #ifndef USE_SETEUID
   int i;
-# ifdef BSDWAIT
+# ifndef HAVE_SYS_WAIT_H
   union wait wstat;
 # else
   int wstat;
diff --git a/src/os.h b/src/os.h
index b56b660..4e2d0c3 100644
--- a/src/os.h
+++ b/src/os.h
@@ -60,6 +60,7 @@
 # define getpgrp __getpgrp
 # define exit __exit
 #endif
+
 #ifdef POSIX
 # include <unistd.h>
 # if defined(__STDC__)
@@ -248,14 +249,14 @@ extern int errno;
  *   utmp handling
  */
 
-#ifdef GETUTENT
+#ifdef HAVE_GETUTENT
   typedef char *slot_t;
 #else
   typedef int slot_t;
 #endif
 
-#if defined(UTMPOK) || defined(BUGGYGETLOGIN)
-# if defined(SVR4) && !defined(DGUX) && !defined(__hpux) && !defined(linux)
+#if defined(UTMPOK) || defined(SVR4)
+# if (defined(HAVE_UTMPX_H) && !defined(HAVE_UTMP_H)) || defined(__ENVIRONMENT_MAC_OS_X_VERSION_MIN_REQUIRED__)
 #  include <utmpx.h>
 #  define UTMPFILE	UTMPX_FILE
 #  define utmp		utmpx
@@ -266,12 +267,12 @@ extern int errno;
 #  define setutent	setutxent
 #  define endutent	endutxent
 #  define ut_time	ut_xtime
-# else /* SVR4 */
+# else
 #  include <utmp.h>
-# endif /* SVR4 */
+# endif
 # ifdef apollo
    /* 
-    * We don't have GETUTENT, so we dig into utmp ourselves.
+    * We don't HAVE_GETUTENT, so we dig into utmp ourselves.
     * But we save the permanent filedescriptor and
     * open utmp just when we need to. 
     * This code supports an unsorted utmp. jw.
@@ -291,7 +292,7 @@ extern int errno;
 #  endif
 # endif
 
-#endif /* UTMPOK || BUGGYGETLOGIN */
+#endif /* UTMPOK || SVR4 */
 
 #if !defined(UTMPOK) && defined(USRLIMIT)
 # undef USRLIMIT
@@ -397,13 +398,8 @@ extern int errno;
  *    signal handling
  */
 
-#ifdef SIGVOID
 # define SIGRETURN
-# define sigret_t void
-#else
-# define SIGRETURN return 0;
-# define sigret_t int
-#endif
+#define sigret_t RETSIGTYPE
 
 /* Geeeee, reverse it? */
 #if defined(SVR4) || (defined(SYSV) && defined(ISC)) || defined(_AIX) || defined(linux) || defined(ultrix) || defined(__386BSD__) || defined(__bsdi__) || defined(POSIX) || defined(NeXT)
@@ -447,7 +443,7 @@ extern int errno;
 #endif
 
 #ifndef WTERMSIG
-# ifndef BSDWAIT /* if wait is NOT a union: */
+# ifdef HAVE_SYS_WAIT_H /* if wait is NOT a union: */
 #  define WTERMSIG(status) (status & 0177)
 # else
 #  define WTERMSIG(status) status.w_T.w_Termsig 
@@ -455,7 +451,7 @@ extern int errno;
 #endif
 
 #ifndef WSTOPSIG
-# ifndef BSDWAIT /* if wait is NOT a union: */
+# ifdef HAVE_SYS_WAIT_H /* if wait is NOT a union: */
 #  define WSTOPSIG(status) ((status >> 8) & 0377)
 # else
 #  define WSTOPSIG(status) status.w_S.w_Stopsig 
@@ -468,7 +464,7 @@ extern int errno;
 #endif
 
 #ifndef WIFCORESIG
-# ifndef BSDWAIT /* if wait is NOT a union: */
+# ifdef HAVE_SYS_WAIT_H /* if wait is NOT a union: */
 #  define WIFCORESIG(status) (status & 0200)
 # else
 #  define WIFCORESIG(status) status.w_T.w_Coredump
@@ -476,7 +472,7 @@ extern int errno;
 #endif
 
 #ifndef WEXITSTATUS
-# ifndef BSDWAIT /* if wait is NOT a union: */
+# ifdef HAVE_SYS_WAIT_H /* if wait is NOT a union: */
 #  define WEXITSTATUS(status) ((status >> 8) & 0377)
 # else
 #  define WEXITSTATUS(status) status.w_T.w_Retcode
diff --git a/src/osdef.h.in b/src/osdef.h.in
index 36964fb..82e4427 100644
--- a/src/osdef.h.in
+++ b/src/osdef.h.in
@@ -72,7 +72,7 @@ extern void  bcopy __P((char *, char *, int));
 extern void  bcopy __P((char *, char *, int));
 #endif
 
-#ifdef BSDWAIT
+#ifndef HAVE_SYS_WAIT_H
 struct rusage;		/* for wait3 __P */
 union wait;		/* for wait3 __P */
 extern int   wait3 __P((union wait *, int, struct rusage *));
@@ -157,7 +157,7 @@ extern int   listen __P((int, int));
 extern int   accept __P((int, struct sockaddr *, int *));
 #endif
 
-#if defined(UTMPOK) && defined(GETUTENT)
+#if defined(UTMPOK) && defined(HAVE_GETUTENT)
 extern void  setutent __P((void));
 #endif
 
@@ -176,7 +176,7 @@ extern int   utimes __P((char *, struct timeval *));
 
 extern void  unsetenv __P((char *));
 
-# if defined(GETTTYENT) && !defined(GETUTENT) && !defined(UTNOKEEP)
+# if defined(GETTTYENT) && !defined(HAVE_GETUTENT) && !defined(UTNOKEEP)
 struct ttyent;		/* for getttyent __P */
 extern void  setttyent __P((void));
 extern struct ttyent *getttyent __P((void));
diff --git a/src/osdef.sh b/src/osdef.sh
index b281175..725e004 100644
--- a/src/osdef.sh
+++ b/src/osdef.sh
@@ -35,7 +35,7 @@ cat << EOF > osdef0.c
 #include <syslog.h>
 #endif
 #include "os.h"
-#if defined(UTMPOK) && defined (GETTTYENT) && !defined(GETUTENT)
+#if defined(UTMPOK) && defined (GETTTYENT) && !defined(HAVE_GETUTENT)
 #include <ttyent.h>
 #endif
 #ifdef SVR4
diff --git a/src/screen.c b/src/screen.c
index 7d1865e..107c947 100644
--- a/src/screen.c
+++ b/src/screen.c
@@ -1464,7 +1464,7 @@ char **av;
 void
 WindowDied(p, wstat, wstat_valid)
 struct win *p;
-#ifdef BSDWAIT
+#ifndef HAVE_SYS_WAIT_H
   union wait wstat;
 #else
   int wstat;
@@ -1473,7 +1473,7 @@ int wstat_valid;
 {
   int killit = 0;
 
-#if defined(BSDJOBS) && !defined(BSDWAIT)
+#if defined(BSDJOBS) && defined(HAVE_SYS_WAIT_H)
   if (!wstat_valid && p->w_pid > 0)
     {
       /* EOF on file descriptor. The process is probably also dead.
@@ -1662,14 +1662,14 @@ DoWait()
 {
   register int pid;
   struct win *p, *next;
-#ifdef BSDWAIT
+#ifndef HAVE_SYS_WAIT_H
   union wait wstat;
 #else
   int wstat;
 #endif
 
 #ifdef BSDJOBS
-# ifndef BSDWAIT
+# ifdef HAVE_SYS_WAIT_H
   while ((pid = waitpid(-1, &wstat, WNOHANG | WUNTRACED)) > 0)
 # else
 # ifdef USE_WAIT2
diff --git a/src/socket.c b/src/socket.c
index 7832832..8aae00d 100644
--- a/src/socket.c
+++ b/src/socket.c
@@ -31,6 +31,9 @@
 #include <sys/stat.h>
 #include <fcntl.h>
 #if !defined(NAMEDPIPE)
+#ifdef HAVE_SYS_UIO_H
+# include <sys/uio.h>
+#endif
 #include <sys/socket.h>
 #include <sys/un.h>
 #endif
diff --git a/src/termcap.c b/src/termcap.c
index 2b63a24..87083f0 100644
--- a/src/termcap.c
+++ b/src/termcap.c
@@ -361,7 +361,7 @@ int he;
   if (D_CG0)
     {
       if (D_CS0 == 0)
-#ifdef TERMINFO
+#if defined(TERMINFO) || defined(__FreeBSD__)
         D_CS0 = "\033(%p1%c";
 #else
         D_CS0 = "\033(%.";
diff --git a/src/terminfo/checktc.c b/src/terminfo/checktc.c
index ccc9485..acba34e 100644
--- a/src/terminfo/checktc.c
+++ b/src/terminfo/checktc.c
@@ -171,6 +171,7 @@ char *s;
   fflush(stdout);
 }
 
+#ifndef __FreeBSD__
 void CPutStr(s, c)
 char *s;
 int c;
@@ -186,6 +187,7 @@ int x, y;
   tputs(tgoto(s, y, x), 1, putcha);
   fflush(stdout);
 }
+#endif /* __FreeBSD__ */
 
 void GotoPos(x,y)
 int x,y;
diff --git a/src/utmp.c b/src/utmp.c
index 20f3c3c..8771730 100644
--- a/src/utmp.c
+++ b/src/utmp.c
@@ -74,7 +74,7 @@ extern int real_uid, eff_uid;
  *  we have a suid-root helper app that changes the utmp for us
  *  (won't work for login-slots)
  */
-#if (defined(sun) && defined(SVR4) && defined(GETUTENT)) || defined(HAVE_UTEMPTER)
+#if (defined(sun) && defined(SVR4) && defined(HAVE_GETUTENT)) || defined(HAVE_UTEMPTER)
 # define UTMP_HELPER
 #endif
 
@@ -88,13 +88,13 @@ static void makeuser __P((struct utmp *, char *, char *, int));
 static void makedead __P((struct utmp *));
 static int  pututslot __P((slot_t, struct utmp *, char *, struct win *));
 static struct utmp *getutslot __P((slot_t));
-#ifndef GETUTENT
+#ifndef HAVE_GETUTENT
 static struct utmp *getutent __P((void));
 static void endutent __P((void));
 static int  initutmp __P((void));
 static void setutent __P((void));
 #endif
-#if defined(linux) && defined(GETUTENT)
+#if defined(linux) && defined(HAVE_GETUTENT)
 static struct utmp *xpututline __P((struct utmp *utmp));
 # define pututline xpututline
 #endif
@@ -107,21 +107,21 @@ static int utmpfd = -1;
 #endif
 
 
-# if defined(GETUTENT) && (!defined(SVR4) || defined(__hpux)) && ! defined(__CYGWIN__)
-#  if defined(hpux) /* cruel hpux release 8.0 */
+# if defined(HAVE_GETUTENT) && (!defined(SVR4) || defined(__hpux)) && ! defined(__CYGWIN__)
+#  if defined(HAVE__PUTUTLINE) /* cruel hpux release 8.0 */
 #   define pututline _pututline
-#  endif /* hpux */
+#  endif /* HAVE__PUTUTLINE */
 extern struct utmp *getutline(), *pututline();
 #  if defined(_SEQUENT_)
 extern struct utmp *ut_add_user(), *ut_delete_user();
 extern char *ut_find_host();
-#   ifndef UTHOST
-#    define UTHOST		/* _SEQUENT_ has ut_find_host() */
+#   ifndef HAVE_STRUCT_UTMP_UT_HOST
+#    define HAVE_STRUCT_UTMP_UT_HOST		/* _SEQUENT_ has ut_find_host() */
 #   endif
 #  endif /* _SEQUENT_ */
-# endif /* GETUTENT && !SVR4 */
+# endif /* HAVE_GETUTENT && !SVR4 */
 
-# if !defined(GETUTENT) && !defined(UT_UNSORTED)
+# if !defined(HAVE_GETUTENT) && !defined(UT_UNSORTED)
 #  ifdef GETTTYENT
 #   include <ttyent.h>
 #  else
@@ -129,13 +129,13 @@ struct ttyent { char *ty_name; };
 static void           setttyent __P((void));
 static struct ttyent *getttyent __P((void));
 #  endif
-# endif /* !GETUTENT && !UT_UNSORTED */
+# endif /* !HAVE_GETUTENT && !UT_UNSORTED */
 
 #ifndef _SEQUENT_
 # undef  D_loginhost
 # define D_loginhost D_utmp_logintty.ut_host
 #endif
-#ifndef UTHOST
+#ifndef HAVE_STRUCT_UTMP_UT_HOST
 # undef  D_loginhost
 # define D_loginhost ((char *)0)
 #endif
@@ -273,10 +273,10 @@ InitUtmp()
       utmpok = 0;
       return;
     }
-# ifdef GETUTENT
+# ifdef HAVE_GETUTENT
   close(utmpfd);	/* it was just a test */
   utmpfd = -1;
-# endif /* GETUTENT */
+# endif /* HAVE_GETUTENT */
 #endif	/* UTMP_HELPER */
   utmpok = 1;
 }
@@ -409,12 +409,12 @@ struct win *wi;
   register slot_t slot;
   struct utmp u;
   int saved_ut;
-#ifdef UTHOST
+#ifdef HAVE_STRUCT_UTMP_UT_HOST
   char *p;
   char host[sizeof(D_loginhost) + 15];
 #else
   char *host = 0;
-#endif /* UTHOST */
+#endif /* HAVE_STRUCT_UTMP_UT_HOST */
 
   wi->w_slot = (slot_t)0;
   if (!utmpok || wi->w_type != W_TYPE_PTY)
@@ -434,7 +434,7 @@ struct win *wi;
   if (!saved_ut)
     makeuser(&u, stripdev(wi->w_tty), LoginName, wi->w_pid);
 
-#ifdef UTHOST
+#ifdef HAVE_STRUCT_UTMP_UT_HOST
   host[sizeof(host) - 15] = '\0';
   if (display)
     {
@@ -477,7 +477,7 @@ struct win *wi;
 # if !defined(_SEQUENT_) && !defined(sequent)
   strncpy(u.ut_host, host, sizeof(u.ut_host));
 # endif
-#endif /* UTHOST */
+#endif /* HAVE_STRUCT_UTMP_UT_HOST */
 
   if (pututslot(slot, &u, host, wi) == 0)
     {
@@ -546,7 +546,7 @@ struct win *wi;
  *  routines using the getut* api
  */
 
-#ifdef GETUTENT
+#ifdef HAVE_GETUTENT
 
 #define SLOT_USED(u) (u->ut_type == USER_PROCESS)
 
@@ -598,7 +598,7 @@ makedead(u)
 struct utmp *u;
 {
   u->ut_type = DEAD_PROCESS;
-#if (!defined(linux) || defined(EMPTY)) && !defined(__CYGWIN__)
+#if (!defined(linux) || defined(EMPTY)) && !defined(__CYGWIN__) && !defined(__ENVIRONMENT_MAC_OS_X_VERSION_MIN_REQUIRED__)
   u->ut_exit.e_termination = 0;
   u->ut_exit.e_exit = 0;
 #endif
@@ -642,7 +642,7 @@ char *nam;
 }
 
 
-#else /* GETUTENT */
+#else /* HAVE_GETUTENT */
 
 /*********************************************************************
  *
@@ -724,7 +724,7 @@ struct utmp *u;
 {
 #ifdef UT_UNSORTED
   bzero(u->ut_name, sizeof(u->ut_name));
-# ifdef UTHOST
+# ifdef HAVE_STRUCT_UTMP_UT_HOST
   bzero(u->ut_host, sizeof(u->ut_host));
 # endif
 #else
@@ -774,7 +774,7 @@ char *nam;
   return slot;
 }
 
-#endif	/* GETUTENT */
+#endif	/* HAVE_GETUTENT */
 
 
 
@@ -783,7 +783,7 @@ char *nam;
  *  Cheap plastic imitation of ttyent routines.
  */
 
-#if !defined(GETTTYENT) && !defined(GETUTENT) && !defined(UT_UNSORTED)
+#if !defined(GETTTYENT) && !defined(HAVE_GETUTENT) && !defined(UT_UNSORTED)
 
 
 static char *tt, *ttnext;
@@ -825,7 +825,7 @@ getttyent()
   return &t;
 }
 
-#endif	/* !GETTTYENT && !GETUTENT && !UT_UNSORTED*/
+#endif	/* !GETTTYENT && !HAVE_GETUTENT && !UT_UNSORTED*/
 
 
 
@@ -839,7 +839,7 @@ getttyent()
  *  getlogin() replacement (for SVR4 machines)
  */
 
-# if defined(BUGGYGETLOGIN) && defined(UTMP_FILE)
+# if defined(SVR4) && defined(UTMP_FILE)
 char *
 getlogin()
 {
@@ -871,9 +871,9 @@ getlogin()
 
   return *retbuf ? retbuf : NULL;
 }
-# endif /* BUGGYGETLOGIN */
+# endif /* SVR4 */
 
-#if defined(linux) && defined(GETUTENT)
+#if defined(linux) && defined(HAVE_GETUTENT)
 # undef pututline
 
 /* aargh, linux' pututline returns void! */
diff --git a/src/window.c b/src/window.c
index fb271d2..4426f0f 100644
--- a/src/window.c
+++ b/src/window.c
@@ -1855,7 +1855,7 @@ char *data;
 	return;
 #endif
       debug2("Window %d: read error (errno %d) - killing window\n", p->w_number, errno);
-#ifdef BSDWAIT
+#ifndef HAVE_SYS_WAIT_H
       WindowDied(p, (union wait)0, 0);
 #else
       WindowDied(p, 0, 0);
@@ -1865,7 +1865,7 @@ char *data;
   if (len == 0)
     {
       debug1("Window %d: EOF - killing window\n", p->w_number);
-#ifdef BSDWAIT
+#ifndef HAVE_SYS_WAIT_H
       WindowDied(p, (union wait)0, 0);
 #else
       WindowDied(p, 0, 0);
